  processor 6502

  seg
  org $8000
  byte 0
  org $8100
  nop $1FF8

  org $8155  ; Jumping-in point in $1FF9 block (from $1FF8)
  nop $1FF9

  org $8169  ; Jumping-in point in $1FF8 block (from $1FF9)
  nop $1FF8

  org $8553  ; Jumping-out point in $1FF9 block (going to $1FF8)
  jmp $5169

  org $8C39  ; Jumping-out point in $1FF8 block (going to $1FF9)
  jmp $5155

  org $8FFC
  word $9100,$9100
  org $9100
  nop $1FF8

  org $9871-3  ; Draw things on scanner here
drawx:
  nop $1FF8
  jmp do_draw

  org $9908
x908:
  nop $1FF8
do_draw:
  lda #$00
  ldy #6
zlp:
  sta $F04F,y
  sta $F04F+7,y
  sta $F04F+14,y
  sta $F04F+21,y
  sta $F04F+28,y
  sta $F04F+35,y
  dey
  bpl zlp  
  lda $81
  and #7
  tax
  lda cbtable,x
  sta $F07F
  and #$55
  bne no_humanoids
  lda $f080 ; X scroll position
  lsr
  lsr
  lsr
  lsr
  tax
  ldy xdtable,x

  lda $D6
  lsr
  bcc no_c0_human
  sty $F04F+14
no_c0_human:
  lsr
  bcc no_c1_human
  sty $F04F+21
no_c1_human:
  lsr
  bcc no_c2_human
  sty $F04F+28
no_c2_human:
  lsr
  bcc no_c3_human
  sty $F04F+35
no_c3_human:
  lsr
  bcc no_c4_human
  sty $F04F+0
no_c4_human:
  lsr
  bcc no_c5_human
  sty $F04F+7
no_c5_human:
no_humanoids:
  ldx #15
dlp:
  dex
  bmi dlp_exit
dlp1:
  ldy $F0A2,x
  beq dlp
  cpy #13
  beq abductor
  cpy #16
  bcs dlp
  lda ctable,y
  beq abductor
  bit $70FF
  beq dlp
  lda $F082,x
  asl
  lda $F0B2,x
  rol
  and #7
  tay
  lda xatable,y
  beq dlp
  sta $F1
f1_stowed:
  lda $F082,x  ; X position low byte
  and #$7F
  lsr
  lsr
  lsr
  lsr
  tay
  lda xdtable,y
  sta $F0
  lda $E0,x ; Y position
  lsr
  lsr
  lsr
  tay
  lda ytable,y
  clc
  adc $F1
  tay
  lda $F0CE,y
  ora $F0
  sta $F04E,y
dlp_alt:
  dex
  bpl dlp1
dlp_exit:
  ldx $F0FA
  lda FAtbl,x
  sta $F07A

  lda $81
  lsr
  lda #$B4
  ror
  sta $f07F
  
  jmp [x908 & $0FFF] | $D000

abductor:
  lda $F082,x
  asl
  lda $F0B2,x
  rol
  and #7
  tay
  lda xatable,y
  beq dlp_alt
  sta $F1
  lda $81
  and #1
  bne f1_stowed
  dec $f1
  jmp f1_stowed

  org $9A00
xatable:
  byte 15,23,29,36,0,0,1,8
xdtable:
cbtable:
  byte 128,64,32,16,8,4,2,1
ytable:  ; DCD8
  byte 255,0,0,1, 1,2,2,3, 3,3,4,4, 5,5,6,6, 6,6,6,6
FAtbl:
  byte 1,2,3,6,0,0,7,0
ctable:
  byte %11111111  ; 0 No enemy
  byte %10100101  ; 1 Baiter
  byte %10100101  ; 2 Munchie
  byte %10100101  ; 3 Phred
  byte %10100100  ; 4 Mutant
  byte %10100101  ; 5 Guppy
  byte %11001100  ; 6 Three swarmers
  byte %11001100  ; 7 Two swarmers
  byte %11001100  ; 8 One swarmer
  byte %01010101  ; 9 Lander
  byte %10100101  ; A Dynamo
  byte %11110000  ; B Pod
  byte %10100101  ; C Firebomber
  byte %00000000  ; D Abductor
  byte %10101010  ; E Humanoid (falling safe)
  byte %10100000  ; F Humanoid (falling danger)


  org $9FFC
  word $9100,$9100

  end






